#include "ConfigParser.h"
#include <fstream>
#include <iostream>

ConfigParser::ConfigParser(std::string file_name) {
	this->file_name = file_name;
	if (file_name.length()) {
		parse(file_name);
	}
}

ConfigParser::~ConfigParser(){}

bool ConfigParser::parse(std::string file_name) {
	this->file_name = file_name;
	std::fstream stream(file_name.c_str(), std::ios_base::in);
	if (!stream.is_open()) return false;
	while (!stream.eof()) {
		std::string line;
		std::getline(stream, line);
		std::string::size_type pos;

		if ((pos = line.find_first_of("#")) != std::string::npos) {
			// there is a comment here
			line = std::string(line, 0, pos);
		}

		std::stringstream strstream(line, std::ios::in);
		std::string key, value;
		strstream >> key;// >> value;


		// skip spaces and tabs
		char c;
		while ((c = strstream.get()) == ' ' || c == '\t') {}
		strstream.unget();

		std::getline(strstream, value);

		// drop trailing spaces and tabs
		if ((pos = value.find_first_of(" \t", value.find_last_not_of(" \t"))) != std::string::npos) {
			value.erase(pos);
		}

		if (key.length() && value.length()) {
			values[key] = value;
		}
	}
	stream.close();
	return true;
}

int ConfigParser::get_value_int(std::string const & key) {
	int value;
	std::stringstream stream(values[key], std::ios::in);
	stream >> value;

	return value;
}

double ConfigParser::get_value_double(std::string const & key) {
	double value;
	std::stringstream stream(values[key], std::ios::in);
	stream >> value;

	return value;
}

bool ConfigParser::get_value_bool(std::string const & key) {
	std::string value = get_value_string(key);
	if (value[0] == 't' || value[0] == 'T' || value[0] == 'y' || value[0] == 'Y') {
		return true;
	} else {
		return false;
	}
}
