#ifndef FONT_HEADER_INCLUDED
#define FONT_HEADER_INCLUDED

#include "xlib.h"
#include <X11/Xft/Xft.h>
#include <string>

namespace Visibility {

class Font {
	public:
		Font(std::string name);
		~Font();

		class TextMetrics {
			public:
				XGlyphInfo extents;
				int ascent;
				int descent;
				int height;
				inline unsigned calculate_baseline(unsigned height) {
					return unsigned((height - (ascent + descent)) / 2.0) + ascent;
				}
		};	

		void get_metrics(std::string text, TextMetrics & metrics);
		XftFont * font;
};

}

#endif
