// the main pager logic class
// this class tries not to deal with server and event things itself.
// main() should usually call the appropriate functions to notify the pager
// of what occurred.

#include "Desktop.h"

namespace Visibility {

	class Pager {
	public:
		Pager(void);
		~Pager();

		std::tr1::shared_ptr<Window> main;
	protected:
		void number_of_desktops_changed_callback(void);
		void window_changed_desktop_callback(::Window window);
		void current_desktop_changed_callback(void);

		XSizeHints * hints;
		XWMHints * wm_hints;

		::Window active_window;

		void reinitialize(void);
		void fill_pixmap(std::tr1::shared_ptr<Pixmap> pixmap);
		void position_internals(void);
		void resize(void);

		// moves the pager window to the right place.
		void position(void);

		unsigned calculate_width(void);

		// sets everything up (and again, if reinitialize is true)
		void initialize(void);
		CARD32 number_of_desktops;
		CARD32 current_desktop;

		std::vector< std::tr1::shared_ptr<Desktop> > desktops;

		unsigned width, height;
	};

}
